using System.Text.Json.Serialization;

namespace Luski.Clesses;

public class Settings
{
    [JsonInclude]
    [JsonPropertyName("scale")]
    public double Scale { get; set; } = 1;
    [JsonInclude]
    [JsonPropertyName("perscrollpixels")]
    public uint PerScrollPixels { get; set; } = 20;
    [JsonInclude]
    [JsonPropertyName("multithreadpercent")]
    public uint MultiThreadPercent { get; set; } = 50;
    [JsonInclude]
    [JsonPropertyName("loadperchannel")]
    public int LoadPerChannel { get; set; } = 50;
}

[JsonSerializable(typeof(Settings))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = true,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
internal partial class SettingsContext : JsonSerializerContext
{

}