using GraphicsManager.Interfaces;
using GraphicsManager.Objects;
using GraphicsManager.Objects.Core;
using Luski.net.JsonTypes;
using Luski.GUI.MainScreen.Interfaces;
using OpenTK.Mathematics;

namespace Luski.GUI.MainScreen.UI;

public class Group : UserControl, IChannelPick
{
    public SocketTextChannel Channel { get; set; }
    private string members = "";
    private Rectangle r;
    private Label Username, Status;
    public Group(SocketGroupChannel chan)
    {
        Channel = chan;
        Size = new((int)(185 * Globals.Settings.Scale), (int)(48* Globals.Settings.Scale));
        BackgroundColor = new(34, 34, 34, 255);
        Controls.Add( r = new Rectangle(Globals.ms.TextureManager.AddTexture(chan.GetPicture(CancellationToken.None).Result)) { Location = new((int)(7.5 * Globals.Settings.Scale),(int)(8.5 * Globals.Settings.Scale)), Size = new((int)(29* Globals.Settings.Scale))});
        Controls.Add(Username = new Label() { Font = Globals.DefaultFont, Text = chan.Title, Location = new((int)(38.5 * Globals.Settings.Scale),(int)(10 * Globals.Settings.Scale))});
        string sl = "Online";
        if (chan.Id != 0)
        {
            sl = chan.Members.Count + " Members";
        }
        Controls.Add(Status = new Label() { Font = Globals.DefaultFont, Text = sl, Location = new((int)(38.5 * Globals.Settings.Scale),(int)(24 * Globals.Settings.Scale))});
        this.Clicked += AllOnClicked;
        if (chan.Id == 0) return;
        ContextMenu = new((int)(150 * Globals.Settings.Scale));
        RoundedButton rr;
        ContextMenu.Items.Add(rr=new()
        {
            InsideColor = new(28, 28, 28, 255), BorderColor = Color4.DarkCyan,
            Size = new((int)(25 * Globals.Settings.Scale)), Font = Globals.DefaultFont, Text = "Export Keys"
        });
        rr.Clicked += RrOnClicked;
    }

    private Task RrOnClicked(IRenderObject arg)
    {
        _ = Channel.SendKeysToUsers(CancellationToken.None);
        ContextMenu!.HideContext(Window!);
        return Task.CompletedTask;
    }
    
    private Task AllOnClicked(IRenderObject arg)
    {
        if (ClickCon is not null) _ = ClickCon.Invoke(this);
        return Task.CompletedTask;
    }

    public event Func<IChannelPick, Task> ClickCon;
}